from types import StringType, UnicodeType

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass, package_home
from OFS.SimpleItem import SimpleItem
from Products.CMFCore.CMFCorePermissions  import ManagePortal, ModifyPortalContent, View
from Products.CMFCore.ActionInformation import ActionInformation
from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.utils import UniqueObject, getToolByName
from StringIO import StringIO
from Acquisition import aq_base

from config import VIEW_PERMISSION #, product_name, unique_id

from rssparser import parse
from random import choice

class PloneliciousTool(UniqueObject, ActionProviderBase, SimpleItem):
    """ Plonelicious Tool class   """

    id        = 'plonelicious_tool'
    meta_type = 'Plonelicious Tool'

    security = ClassSecurityInfo()
    
    _actions = [ActionInformation(
        id='delicious',
        title='Post to del.icio.us',
        action="string:javascript:(function(){open('http://del.icio.us/post?v=3&noui=yes&jump=close&url='+encodeURIComponent(location.href)+'&title='+encodeURIComponent(document.title),'delicious','toolbar=no,width=700,height=250')})()",
        permissions=(VIEW_PERMISSION,),
        condition="",
        category='document_actions',
        visible=1
        )]

    manage_options=(
        SimpleItem.manage_options
        +  ActionProviderBase.manage_options
        )

    security.declarePublic('parse_rss')
    def parse_rss(self, tags, user):
        tag=choice(tags)
        if user==False:
            # if there's no username, just supply all delicious links with the supplied tag
            user="tag"
        #url="http://localhost/plone.xml"
        url="http://del.icio.us/rss/"+user+"/"+tag
        feedvals=parse(url)
        # Restrict to 5 items for portlet
        return feedvals['items'][:5]

InitializeClass(PloneliciousTool)
